//****************************************************************
//
//    Builtin Operators
//
//    Description:
//	Contains all of the builtin operators.
//
//      If you discover any bugs, it would be very helpful if
//      you sent me e-mail.  Thank you.
//
//      Author:                Peter Braaten
//      e-mail:                braa0007@mermaid.micro.umn.edu
//      Date last modified:    July 18, 1995
//
//****************************************************************



#ifndef OPERATOR_H
#define OPERATOR_H

#include <string.h>
#include "value.h"

value * _or (value *, value *, int &);
value * _and (value *, value *, int &);
value * lt (value *, value *, int &);
value * le (value *, value *, int &);
value * eq (value *, value *, int &);
value * ge (value *, value *, int &);
value * gt (value *, value *, int &);
value * ne (value *, value *, int &);
value * plus (value *, value *, int &);
value * minus (value *, value *, int &);
value * mult (value *, value *, int &);
value * emult (value *, value *, int &);
value * div (value *, value *, int &);
value * ediv (value *, value *, int &);
value * ldiv (value *, value *, int &);
value * eldiv (value *, value *, int &);
value * transp (value *, int &);
value * uplus (value *, int &);
value * uminus (value *, int &);
value * inc (value *, int &);
value * dec (value *, int &);
value * _not (value *, int &);
value * pow (value *, value *, int &);
value * epow (value *, value *, int &);

#endif
