#!/usr/local/bin/wish4.1

#
# procs.tcl
# ~~~~~~~~~
#
#   This file is included from spmath.tcl and defines a few
# useful procedures used by spmath.
#
# Author: Ben Langmead (btl10@columbia.edu)
# Date:   July 3, 2001
#

#
# proc text_out: called from output.C to display result of
#                yyparse.  Uses result_tag to format text.
#
proc text_out { str } {
    .t insert end $str result_tag
}

#
# proc error_out: called from output.C to display error messages
#
proc error_out { str } {
    .t insert end $str error_tag
}

#
# proc command_out: called from output.C to replace the user's
#                   current command line with a string retrieved 
#                   from the history list.
#
proc command_out { str } {

    .t delete "insert linestart +3 chars" "insert lineend"
    .t mark set insert end

    .t insert end $str
    .t mark set insert end
}

# Inserts the normal prompt at the end of the text
proc put_prompt { } {
    global prompt
    global autoscroll

    .t insert end $prompt

    if $autoscroll then {
	.t see insert
    } else {
	set autoscroll 1
    }
}

proc put_nested_prompt { } {
    global nest_prompt
    global autoscroll

    .t insert end $nest_prompt

    if $autoscroll then {
	.t see insert
    } else {
	set autoscroll 1
    }
}

# Turns the autoscroll to the end of the output text
# off until the end of the next command completed.
proc turn_autoscroll_off { } {
    global autoscroll

    set autoscroll 0
}

# Simply pages down.  Used to display help properly.
proc page_down { } {
    tkTextScrollPages .t 1
}







