#ifndef NO_TK_COMPILE
#include <tk.h>
#endif

#include "sparse.h"
#include "dense.h"
#include "value.h"
#include "string.h"
#include "history.h"
#include "csparse.h"
#include "entry.h"
#include "funct_def.h"
#include "functions.h"
#include "symtab.h"
#include "io.h"
#include "operators.h"

#ifndef NO_TK_COMPILE
#include "view/view.h"
#endif

#define MAX_VIEWS 999

#define MANPAGE_DIR_NAME "manpage"
#define MATRIX_DIR_NAME "matrices"
#define SCRIPT_DIR_NAME "scripts"
extern char spmathpath[128];


// spmath.y
int sp_parse(const char *input);
extern int yyerror(char *);
extern int yyerror(const char *);

// main.C
void sp_init();
void sp_quit(int);

#ifndef NO_TK_COMPILE
extern int no_tk;
#endif

// output.C
void sp_out(const char *);
void sp_out(int);
void sp_out(long);
void sp_out(double);
void sp_out(float);
void sp_error(const char *);
void sp_error(int);
void sp_error(long);
void sp_error(double);
void sp_error(float);
void sp_command(const char *);
void sp_prompt();

// tcl.C

#ifndef NO_TK_COMPILE

void TCL(const char *);
void create_tcl_commands();

extern Tcl_Interp *interp;
extern view *spyviews[MAX_VIEWS];
extern int cur_spyview;

#endif

extern int supress_output;
extern int nest_count;
extern int hist_num;
extern int hist_cur;

extern history hist_list;


