#include "../sparse.h"
#include "../dense.h"

typedef struct {
  unsigned char r;
  unsigned char g;
  unsigned char b;
} view_rgb;

class view {

public:
  view();
  view(sparse&);
  view(dense&);
  ~view();

  void create();
  void draw();

  void set_matrix(sparse &);
  void set_matrix(dense &);

  void create_tk_window();
  void delete_tk_window();

  void set_stats();

  void mouse_track(int, int, int);
  void zoom(int);
  void zoom_out();
  void resize(int, int, int, int);
  void recolor(unsigned char, unsigned char, unsigned char,
	       unsigned char, unsigned char, unsigned char);

private:
  sparse *sp;

  char targ[64];

  view_rgb palette[21];

  Tk_PhotoHandle     hphoto;
  Tk_PhotoHandle     hspread;
  Tk_PhotoImageBlock gblock;

  int image_ht;
  int image_wd;

  int spread_ht;
  int spread_wd;

  int mat_xoff;
  int mat_yoff;
  
  int mat_ht;
  int mat_wd;

  int image_xoff;
  int image_yoff; 

  int dim;

  sparse_stats stats;

  void draw_sparse();

  void set_labels();

  void set_max_block_size(int, int);

  void put_block(Tk_PhotoHandle, int, int, int, int, 
		 unsigned char, unsigned char, unsigned char);

  void put_block_prepared(int, int, int, int, 
			  unsigned char, unsigned char, unsigned char);


  void put_pixel(int, int, 
		 unsigned char, unsigned char, unsigned char);

  void clear();
  void update();
  void status(const char *);
};




